// mozileConfiguration.js

/* ***** BEGIN LICENSE BLOCK *****
 * Licensed under Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * Full Terms at http://mozile.mozdev.org/license.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Playsophy code.
 *
 * The Initial Developer of the Original Code is Playsophy
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		Karl Guertin <grayrest@grayrest.com>
 *		James A. Overton <james@overton.ca>
 *		Christian Stocker (Bitflux)
 *		Paul Everitt
 *		David Palm
 *
 * ***** END LICENSE BLOCK ***** */

/*******

Mozile Configuration Javascript
Mozile version 0.60

Created by James A. Overton
Created on 2004-03-24

Last revised by James A. Overton
Last revised on 2004-03-24

HISTORY:
	Some code in this file was first found in mozilehtmltb.js, while the 
majority was cut out of mozileTB.js and separated into different files.


DESCRIPTION:
	Injects the eDOM code into the current when told to.

*********/


// Mozile Inject
// Load eDOM and related files into the target document, just like mozileChromeLoader.js

function mozileInject(mozileInjectTarget) {
	mozile_js_files = new Array();
	mozile_js_files.push("eDOM.js");
	mozile_js_files.push("eDOMXHTML.js");
	mozile_js_files.push("domlevel3.js");
	mozile_js_files.push("mozCE.js");
	mozile_js_files.push("mozIECE.js");
	
		// Don't change this!
	var MOZILE_EXTENSION_DIR = "chrome://mozile/content/eDOM/"; // default location of mozile is in an extension
	
	// POST04: if document.documentElement != HTML then ... or no "head" ...
	var head = mozileInjectTarget.document.getElementsByTagName("head")[0];

	if(head)
	{

    // Added by Paul to sniff for RSD declarations
    mozileLoadConfig(mozileInjectTarget, head);
    //mozileLoadMES(mozileInjectTarget);
	    
		for (var i=0; i < mozile_js_files.length; i++)
		{
			var scr = document.createElementNS("http://www.w3.org/1999/xhtml","script");
			var src = MOZILE_EXTENSION_DIR + mozile_js_files[i];
			scr.setAttribute("src", src);
			scr.setAttribute("language","JavaScript");
			head.appendChild(scr);
		}

	}
	else
		alert("*** ALERT: MozileLoader only works in XHTML - load Mozile JS explicitly in XML files");

	// Global flag to let you know Mozile has been loaded from chrome.
	mozileInjectTarget.mozileChromeLoaded = "true";

}



function mozileLoadConfig (mozileInjectTarget, headnode) {
	/* Look	for	an RSD declaration and load	configuration if present */

	var	rsdtype	= "application/rsd+xml";
	var	rsdns =	"http://archipelago.phrasewise.com/rsd";
	var	methodxpath	= "//setting[@name='method']";
	var	eoxpath	= "//setting[@name='editonly']";
	var	mesxpath = "//setting[@name='mes']";
	var	tagCSSxpath	= "//setting[@name='tagCSS']";
	var	rsdhref, xmlDoc;

	// Grab	the	head element and look for the RSD link
	// XXX Moz supports	xpath in HTML now, we could	replace	this w/	xpath
	var	links =	headnode.getElementsByTagName("link");
	for	(i=0; i	< links.length;	i++) {
		// Find	out	if the link	element	has	a type attr	for	RSD
		var	l =	links[i];
		if (l.hasAttribute("type") && l.getAttribute("type") ==	rsdtype) {
			rsdhref	= l.getAttribute("href");
		}
	}

	
		mozileInjectTarget.document.MOZILE_RSD_CONFIG =	new	Array();
		// handles the RSD file
	function callback (e) {
		// The RSD is loaded, let's	extract	data into a	config object
	
	//alert(printXML(xmlDoc));
		var	evaluator =	new	XPathEvaluator();
		
		// XXX Hmm,	if the rsd.xml has a namespace decl, the xpath breaks
		// XXX Also, we	should take	any	setting	and	put	it in the array
		var	method = evaluator.evaluate(methodxpath, xmlDoc, null, 
					XPathResult.STRING_TYPE, null).stringValue;
		var	editonly = evaluator.evaluate(eoxpath, xmlDoc, null, 
					XPathResult.STRING_TYPE, null).stringValue;
		var	mes	= evaluator.evaluate(mesxpath, xmlDoc, null, 
					XPathResult.STRING_TYPE, null).stringValue;
		var	tagCSS = evaluator.evaluate(tagCSSxpath, xmlDoc, null, 
					XPathResult.STRING_TYPE, null).stringValue;
	
	//alert(method+editonly+mes+tagCSS);
	
		mozileInjectTarget.document.MOZILE_RSD_CONFIG["rsdhref"]	= rsdhref;
		mozileInjectTarget.document.MOZILE_RSD_CONFIG["method"]	= method;
		mozileInjectTarget.document.MOZILE_RSD_CONFIG["editonly"] =	editonly;
		mozileInjectTarget.document.MOZILE_RSD_CONFIG["mes"] = mes;
		mozileInjectTarget.document.MOZILE_RSD_CONFIG["tagCSS"]	= tagCSS;
		
		window.status =	"Done";
		
		mozileLoadMES(mozileInjectTarget, mes);
	}

	if (rsdhref) {
		window.status =	"Loading RSD at	" +	rsdhref;
	
		xmlDoc = mozileInjectTarget.document.implementation.createDocument(rsdns, 
									"doc", null);
		// XXX:	If this	URL	is relative, it	might not work,	so detect this
		xmlDoc.load(rsdhref);
		xmlDoc.onload =	callback;
	}
		// default to the built in XHTML Editing Scheme.
	else {
		mozileLoadMES(mozileInjectTarget,"XHTML");
	}

	return;
}

